org.jboss.resteasy.plugins.providers

## Class SerializableProvider

- java.lang.Object
- - org.jboss.resteasy.plugins.providers.SerializableProvider

- All Implemented Interfaces:
    MessageBodyReader<Serializable>, MessageBodyWriter<Serializable>

      @Provider
      @Produces(value="application/x-java-serialized-object")
      @Consumes(value="application/x-java-serialized-object")
      public class SerializableProvider
      extends Object
      implements MessageBodyReader<Serializable>, MessageBodyWriter<Serializable>

  Version:
    $Revision: 1.1 $ Created Mar 23, 2012
  Author:
    Ron Sigal

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `APPLICATION_SERIALIZABLE`
    `static MediaType` | `APPLICATION_SERIALIZABLE_TYPE`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SerializableProvider()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `long` | `getSize(Serializable t, Class<?> type, Type genericType, Annotation[] annotations, MediaType mediaType)` Originally, the method has been called before `writeTo` to ascertain the length in bytes of the serialized form of `t`.
    `boolean` | `isReadable(Class<?> type, Type genericType, Annotation[] annotations, MediaType mediaType)` Ascertain if the MessageBodyReader can produce an instance of a particular type.
    `boolean` | `isWriteable(Class<?> type, Type genericType, Annotation[] annotations, MediaType mediaType)` Ascertain if the MessageBodyWriter supports a particular type.
    `Serializable` | `readFrom(Class<Serializable> type, Type genericType, Annotation[] annotations, MediaType mediaType, MultivaluedMap<String,String> httpHeaders, InputStream entityStream)` Read a type from the `InputStream`.
    `void` | `writeTo(Serializable t, Class<?> type, Type genericType, Annotation[] annotations, MediaType mediaType, MultivaluedMap<String,Object> httpHeaders, OutputStream entityStream)` Write a type to an HTTP message.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### APPLICATION_SERIALIZABLE_TYPE

          public static final MediaType APPLICATION_SERIALIZABLE_TYPE

    - #### APPLICATION_SERIALIZABLE

          public static final String APPLICATION_SERIALIZABLE

  - ### Constructor Detail

    - #### SerializableProvider

          public SerializableProvider()

  - ### Method Detail

    - #### isWriteable

          public boolean isWriteable(Class<?> type,
                            Type genericType,
                            Annotation[] annotations,
                            MediaType mediaType)

      Description copied from interface: `MessageBodyWriter`
      Ascertain if the MessageBodyWriter supports a particular type.
      Specified by:
        `isWriteable` in interface `MessageBodyWriter<Serializable>`
      Parameters:
        `type` - the class of instance that is to be written.
        `genericType` - the type of instance to be written, obtained either by reflection of a resource method return type or via inspection of the returned instance. `GenericEntity` provides a way to specify this information at runtime.
        `annotations` - an array of the annotations attached to the message entity instance.
        `mediaType` - the media type of the HTTP entity.
      Returns:
        `true` if the type is supported, otherwise `false`.

    - #### getSize

          public long getSize(Serializable t,
                     Class<?> type,
                     Type genericType,
                     Annotation[] annotations,
                     MediaType mediaType)

      Description copied from interface: `MessageBodyWriter`
      Originally, the method has been called before `writeTo` to ascertain the length in bytes of the serialized form of `t`. A non-negative return value has been used in a HTTP `Content-Length` header.

      As of JAX-RS 2.0, the method has been deprecated and the value returned by the method is ignored by a JAX-RS runtime. All `MessageBodyWriter` implementations are advised to return `-1` from the method. Responsibility to compute the actual `Content-Length` header value has been delegated to JAX-RS runtime.

      Specified by:
        `getSize` in interface `MessageBodyWriter<Serializable>`
      Parameters:
        `t` - the instance to write
        `type` - the class of instance that is to be written.
        `genericType` - the type of instance to be written. `GenericEntity` provides a way to specify this information at runtime.
        `annotations` - an array of the annotations attached to the message entity instance.
        `mediaType` - the media type of the HTTP entity.
      Returns:
        length in bytes or -1 if the length cannot be determined in advance.

    - #### writeTo

          public void writeTo(Serializable t,
                     Class<?> type,
                     Type genericType,
                     Annotation[] annotations,
                     MediaType mediaType,
                     MultivaluedMap<String,Object> httpHeaders,
                     OutputStream entityStream)
                       throws IOException,
                              WebApplicationException

      Description copied from interface: `MessageBodyWriter`
      Write a type to an HTTP message. The message header map is mutable but any changes must be made before writing to the output stream since the headers will be flushed prior to writing the message body.
      Specified by:
        `writeTo` in interface `MessageBodyWriter<Serializable>`
      Parameters:
        `t` - the instance to write.
        `type` - the class of instance that is to be written.
        `genericType` - the type of instance to be written. `GenericEntity` provides a way to specify this information at runtime.
        `annotations` - an array of the annotations attached to the message entity instance.
        `mediaType` - the media type of the HTTP entity.
        `httpHeaders` - a mutable map of the HTTP message headers.
        `entityStream` - the `OutputStream` for the HTTP entity. The implementation should not close the output stream.
      Throws:
        `IOException` - if an IO error arises.
        `WebApplicationException` - if a specific HTTP error response needs to be produced. Only effective if thrown prior to the message being committed.

    - #### isReadable

          public boolean isReadable(Class<?> type,
                           Type genericType,
                           Annotation[] annotations,
                           MediaType mediaType)

      Description copied from interface: `MessageBodyReader`
      Ascertain if the MessageBodyReader can produce an instance of a particular type. The `type` parameter gives the class of the instance that should be produced, the `genericType` parameter gives the `java.lang.reflect.Type` of the instance that should be produced. E.g. if the instance to be produced is `List<String>`, the `type` parameter will be `java.util.List` and the `genericType` parameter will be `java.lang.reflect.ParameterizedType`.
      Specified by:
        `isReadable` in interface `MessageBodyReader<Serializable>`
      Parameters:
        `type` - the class of instance to be produced.
        `genericType` - the type of instance to be produced. E.g. if the message body is to be converted into a method parameter, this will be the formal type of the method parameter as returned by `Method.getGenericParameterTypes`.
        `annotations` - an array of the annotations on the declaration of the artifact that will be initialized with the produced instance. E.g. if the message body is to be converted into a method parameter, this will be the annotations on that parameter returned by `Method.getParameterAnnotations`.
        `mediaType` - the media type of the HTTP entity, if one is not specified in the request then `application/octet-stream` is used.
      Returns:
        `true` if the type is supported, otherwise `false`.

    - #### readFrom

          public Serializable readFrom(Class<Serializable> type,
                              Type genericType,
                              Annotation[] annotations,
                              MediaType mediaType,
                              MultivaluedMap<String,String> httpHeaders,
                              InputStream entityStream)
                                throws IOException,
                                       WebApplicationException

      Description copied from interface: `MessageBodyReader`
      Read a type from the `InputStream`.

      In case the entity input stream is empty, the reader is expected to either return a Java representation of a zero-length entity or throw a `NoContentException` in case no zero-length entity representation is defined for the supported Java type. A `NoContentException`, if thrown by a message body reader while reading a server request entity, is automatically translated by JAX-RS server runtime into a `BadRequestException` wrapping the original `NoContentException` and rethrown for a standard processing by the registered `exception mappers`.

      Specified by:
        `readFrom` in interface `MessageBodyReader<Serializable>`
      Parameters:
        `type` - the type that is to be read from the entity stream.
        `genericType` - the type of instance to be produced. E.g. if the message body is to be converted into a method parameter, this will be the formal type of the method parameter as returned by `Method.getGenericParameterTypes`.
        `annotations` - an array of the annotations on the declaration of the artifact that will be initialized with the produced instance. E.g. if the message body is to be converted into a method parameter, this will be the annotations on that parameter returned by `Method.getParameterAnnotations`.
        `mediaType` - the media type of the HTTP entity.
        `httpHeaders` - the read-only HTTP headers associated with HTTP entity.
        `entityStream` - the `InputStream` of the HTTP entity. The caller is responsible for ensuring that the input stream ends when the entity has been consumed. The implementation should not close the input stream.
      Returns:
        the type that was read from the stream. In case the entity input stream is empty, the reader is expected to either return an instance representing a zero-length entity or throw a `NoContentException` in case no zero-length entity representation is defined for the supported Java type.
      Throws:
        `IOException` - if an IO error arises. In case the entity input stream is empty and the reader is not able to produce a Java representation for a zero-length entity, `NoContentException` is expected to be thrown.
        `WebApplicationException` - if a specific HTTP error response needs to be produced. Only effective if thrown prior to the response being committed.

Copyright © 2014. All Rights Reserved.